'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Spawn = exports.Reduce = exports.Container = exports.ReactReduxApplication = undefined;
exports.wrapReducers = wrapReducers;

var _ReactReduxApplication2 = require('./ReactReduxApplication');

var _ReactReduxApplication3 = _interopRequireDefault(_ReactReduxApplication2);

var _Container2 = require('./Container');

var _Container3 = _interopRequireDefault(_Container2);

var _Reduce2 = require('./Reduce');

var _Reduce3 = _interopRequireDefault(_Reduce2);

var _Spawn2 = require('./Spawn');

var _Spawn3 = _interopRequireDefault(_Spawn2);

var _redux = require('redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.ReactReduxApplication = _ReactReduxApplication3.default;
exports.Container = _Container3.default;
exports.Reduce = _Reduce3.default;
exports.Spawn = _Spawn3.default;
function wrapReducers(reducers) {
  var reducersFns = {};
  Object.keys(reducers).forEach(function (reducerName) {
    var reducer = reducers[reducerName];
    var methods = {};
    Reflect.ownKeys(reducer.__proto__).filter(function (key) {
      return reducer.__proto__[key].__reducer !== undefined;
    }).forEach(function (key) {
      methods[reducer.__proto__[key].__reducer.action] = reducer.__proto__[key];
    });

    reducersFns[reducerName] = wrapReducerMethods(reducer, methods);
  });
  return (0, _redux.combineReducers)(reducersFns);
}

function wrapReducerMethods(reducer, actionHandlers) {
  return function () {
    var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    var action = arguments[1];

    if (actionHandlers[action.type] == undefined) {
      return state;
    }
    return actionHandlers[action.type].apply(reducer, [state, action]);
  };
}